--- pascal/grx.pas.orig	Sun Mar 16 04:41:07 2003
+++ pascal/grx.pas	Fri Apr 25 02:10:07 2003
@@ -56,7 +56,11 @@
 
 type
   MemPtr      = ^Char;
+{$if __GPC_RELEASE__ >= 20030424}
+  GrColor     = Integer attribute (Size = 32);  { color and operation type, must be 32bit }
+{$else}
   GrColor     = Integer (32);  { color and operation type, must be 32bit }
+{$endif}
   GrColorPtr  = ^GrColor;
   GrColors    = array [0 .. MaxVarSize div SizeOf (GrColor) - 1] of GrColor;
   GrColorsPtr = ^GrColors;
    procedure p; abstract;  { WARN }
    procedure p; abstract;  { WARN }
--- test/bgi/bccbgi.c.orig	Wed Feb 26 23:41:44 2003
+++ test/bgi/bccbgi.c	Tue Jun  3 11:02:31 2003
@@ -608,7 +608,7 @@
       itoa( color, cnum, 10 );          /* Convert # to ASCII           */
       outtextxy( x+(width/2), y+height+4, cnum );  /* Show color #      */
 
-      color = ++color % MaxColors;      /* Advance to the next color    */
+      color = (color + 1) % MaxColors;  /* Advance to the next color    */
       x += (width / 2) * 3;             /* move the column base         */
     }                           /* End of Column loop           */
 
@@ -1278,7 +1278,7 @@
     line( x, y, x, h-y );               /* Draw the new line pattern    */
 
     x += 5;                             /* Move the X location of line  */
-    i = ++i % 16;                       /* Advance to next bit pattern  */
+    i = (i + 1) % 16;                   /* Advance to next bit pattern  */
 
     if( style == 0xffff ){              /* Are all bits set?            */
       flag = FALSE;                     /*   begin removing bits        */
--- pascal/readme.orig	Mon Jan  7 01:46:38 2002
+++ pascal/readme	Tue Jun  3 11:26:10 2003
@@ -11,7 +11,7 @@
 
 * blt_test.pas draws some circles
 * modetest.pas prints out the available modes
-* taste.pas prints out the character-codes. Use "Q" to quit.
+* keytest.pas prints out the character-codes. Use "Q" to quit.
 * txt_test.pas prints out some text. Press Return to exit.
 * vir_test.pas lets you draw something.
   Press "1", to place some sqares with the mouse.
--- pascal/makefile.w32.orig	Mon Jan  7 01:51:22 2002
+++ pascal/makefile.w32	Tue Jun  3 11:26:22 2003
@@ -21,7 +21,7 @@
 PROGS= 			\
 	blt_test.exe 	\
 	modetest.exe 	\
-	taste.exe 	\
+	keytest.exe 	\
 	txt_test.exe 	\
 	vir_test.exe	\
 	polytest.exe	\
--- pascal/makefile.dj2.orig	Mon Jan  7 01:50:34 2002
+++ pascal/makefile.dj2	Tue Jun  3 11:26:37 2003
@@ -21,7 +21,7 @@
 PROGS= 			\
 	blt_test.exe 	\
 	modetest.exe 	\
-	taste.exe 	\
+	keytest.exe 	\
 	txt_test.exe 	\
 	vir_test.exe	\
 	polytest.exe	\
--- pascal/makefile.x11.orig	Mon Jan  7 01:53:04 2002
+++ pascal/makefile.x11	Tue Jun  3 11:26:54 2003
@@ -20,7 +20,7 @@
 PROGS= 			\
 	xblt_test 	\
 	xmodetest 	\
-	xtaste	 	\
+	xkeytest	 	\
 	xtxt_test 	\
 	xvir_test	\
 	xpolytest	\
--- pascal/makefile.lnx.orig	Mon Jan  7 01:52:24 2002
+++ pascal/makefile.lnx	Tue Jun  3 11:27:09 2003
@@ -20,7 +20,7 @@
 PROGS= 			\
 	blt_test 	\
 	modetest 	\
-	taste 		\
+	keytest 		\
 	txt_test 	\
 	vir_test	\
 	polytest	\
--- pascal/imgview.pas	Tue May 27 21:17:04 2003
+++ pascal/imgview.pas	Sun Dec 23 02:23:18 2001
@@ -13,7 +13,7 @@
 
 program ImgViewer;
 
-uses GRX, GPC;
+uses GPC, GRX;
 
 var
   GraphicsActive: Boolean = False;
@@ -25,12 +25,12 @@
   GraphicsActive := False
 end;
 
-procedure Warning (Msg: String);
+procedure Warning (const Msg: String);
 begin
   WriteLn (StdErr, ParamStr (0), ': ', Msg)
 end;
 
-procedure Error (Msg: String);
+procedure Error (const Msg: String);
 begin
   CloseGraph;
   Warning (Msg);
--- pascal/makefile.orig	Mon Jan  7 01:48:34 2002
+++ pascal/makefile	Tue Jun  3 11:27:22 2003
@@ -15,7 +15,7 @@
 # I Think, you don't need to change from here
 # --------------------------------------------
 
-all: blt_test modetest taste txt_test vir_test polytest jpgtest colortst imgview
+all: blt_test modetest keytest txt_test vir_test polytest jpgtest colortst imgview
 
 blt_test:blt_test.pas
 	$(COMPILER) $(GRXLIB) $(GRAPHICSLIB) blt_test.pas -oblt_test
@@ -23,8 +23,8 @@
 modetest:modetest.pas
 	$(COMPILER) $(GRXLIB) $(GRAPHICSLIB) modetest.pas -omodetest
 
-taste:	taste.pas
-	$(COMPILER) $(GRXLIB) $(GRAPHICSLIB) taste.pas -otaste
+keytest:	keytest.pas
+	$(COMPILER) $(GRXLIB) $(GRAPHICSLIB) keytest.pas -okeytest
 
 txt_test:txt_test.pas
 	$(COMPILER) $(GRXLIB) $(GRAPHICSLIB) txt_test.pas -otxt_test
@@ -45,6 +45,6 @@
 	$(COMPILER) $(GRXLIB) $(GRAPHICSLIB) imgview.pas -oimgview
 
 clean:
-	rm -f *.o *.gpi blt_test modetest taste txt_test vir_test polytest jpgtest colortst imgview
+	rm -f *.o *.gpi blt_test modetest keytest txt_test vir_test polytest jpgtest colortst imgview
 
 